#include <iostream>
#include "constantes.h"
#include "cronometro.h"

Cronometro::Cronometro(): tParado(0) {}

void Cronometro::iniciar()
{
  tParado = 0;

  tPausa = 0;

  pause = false;

  tActual = SDL_GetTicks();

  tInicio = tActual;
}

void Cronometro::pausa()
{
  tPausa = SDL_GetTicks();
  pause = true;
}

void Cronometro::continuar()
{
  tActual = SDL_GetTicks();

  tParado += tActual - tPausa;

  pause = false;
}

bool Cronometro::tiempoAgotado()
{
  tActual = SDL_GetTicks();
  // Devuelve si han transcurrido más de 60 segundos o no
  if (pause)
    return 0;
  else
    return (tActual - tInicio) > 60000 + tParado;
}

int Cronometro::segundosTranscurridos()
{
  tActual = SDL_GetTicks();

  return ((tActual- tParado) / 1000) - (tInicio / 1000);
}

bool areaCronometro(const Puntero& p)
{
  return ((p.posX() >= CRONOMETRO_X && p.posX() < CRONOMETRO_XW) && (p.posY() >= CRONOMETRO_Y && p.posY() < CRONOMETRO_YH));
}
