#ifndef _CRONOMETRO_H_
#define _CRONOMETRO_H_

#include <SDL/SDL.h>
#include <string>
#include "puntero.h"

using namespace std;

/** Clase Ficha. Clase para el manejo y funcionamiento del cronometro del juego.
*
* Distribuido bajo licencia GNU GPLv.3
*
* @author Daniel Chaves Vázquez
* @version 1.0
*/
class Cronometro
{
 public:

  // Constructor 

  /** Constructor de la clase Cronometro. 
   */
  Cronometro();

  // Modificadores

  /** Función que inicia el cronometro.
   */
  void iniciar();

  /** Método que pausa el cronometro.
   */
  void pausa();

  /** Método que tras, una pausa, hace continuar contando el cronometro.
   */
  void continuar();

  // Observadores

  /** Método que devuelve si el tiempo se ha agotado o no.
   * @return Devuelve si el tiempo se ha agotado o no.
   */
  bool tiempoAgotado();

  /** Método que devuelve el número de segundos transcurridos.
   * @return Devuelve el número de segundos transcurridos.
   */
  int segundosTranscurridos(); 

 private:
  Uint32 tActual, tInicio, tPausa, tParado;
  bool pause;
};

// Funciones externas a la clase

/** Función que devuelve si las coordenadas de un puntero están dentro del area del cronometro o no.
 * @param p Referencia constante a un objeto de la clase Puntero.
 * @return Devuelve si las coordenadas del puntero están o no en el area del cronometro
 */
bool areaCronometro(const Puntero& p);
#endif
