#include <iostream>
#include <sstream>
#include "video.h"
#include "ficha.h"

using namespace std;

Ficha::Ficha(bool com, const unsigned n, const Color c): fComodin(com), num(n), col(c)
{
  if (n != 0) { // Si no es la ficha nula
    const char *ruta = obtenerRuta();
    imagen = new Imagen(ruta);
  }
}

Ficha::Ficha(const Ficha& f)
{
  num = f.num;
  col = f.col;
  fComodin = f.fComodin;
  imagen = f.imagen;
}

Ficha& Ficha:: operator =(const Ficha& f)
{
  if (this != &f) {
    fComodin = f.fComodin;
    num = f.num;
    col = f.col;
    imagen = f.imagen;
  }
  return *this;
}

void Ficha::posicionar(int x, int y)
{
  imagen->modificarX(x);
  imagen->modificarY(y);
}

bool Ficha::modificarComodin(const int n, const Color c)
{
  if (fComodin && (n > 0 && n < 14) &&  (c >= 0 && c < 5)) {
      num = n;
      col = c;
      return true;
  }

  else 
    return false;
}

// Funciones externas a la clase:

bool operator <(const Ficha& f1, const Ficha& f2)
{
  if (f1.color() < f2.color()) // Si un color es "menor" que otro, devolvemos verdadero
    return true;

  else if (f1.color() == f2.color()) { //Si estamos ante el mismo color, tendremos que comprobar el número.
    if (f1.numero() < f2.numero())
      return true;
    else
      return false;
  }

  else
    return false;
}

bool operator ==(const Ficha& f1, const Ficha& f2)
{
  return (f1.color() == f2.color() && f1.numero() == f2.numero());
}

bool operator !=(const Ficha& f1, const Ficha& f2)
{
  return !(f1 == f2);
}

const char* Ficha::obtenerRuta()
{
  string ruta;
  if (fComodin) {
    ruta = "./imagenes/fichas/comodin";
    stringstream ss;
    ss << num;
    ruta += ss.str();

    ruta += ".png";
  }
  
  else
    {
      ruta += "./imagenes/fichas/";

      switch (col)
	{
	case 0: ruta += "verde"; break;
	case 1: ruta += "azul"; break;
	case 2: ruta += "rojo"; break;
	case 3: ruta += "negro"; break;
	default: ruta = "INVALIDA"; break;
	}
      
      switch (num)
	{
	case 1: ruta+= "1"; break;
	case 2: ruta+= "2"; break;
	case 3: ruta+= "3"; break;
	case 4: ruta+= "4"; break;
	case 5: ruta+= "5"; break;
	case 6: ruta+= "6"; break;
	case 7: ruta+= "7"; break;
	case 8: ruta+= "8"; break;
	case 9: ruta+= "9"; break;
	case 10: ruta+= "10"; break;
	case 11: ruta+= "11"; break;
	case 12: ruta+= "12"; break;
	case 13: ruta+= "13"; break;
	default: ruta = "INVALIDA"; break;
	}

      ruta += ".png";
    }

  return ruta.c_str();
}
