#include <iostream>
#include <sstream>
#include <fstream>
#include "constantes.h"
#include "jugador.h"
#include "gestorJugadores.h"

extern bool silencio;

using namespace std;

GestorJugadores::GestorJugadores(): textos("./fuentes/IMPACT.TTF", 30)
{
  fondo = new Imagen("./imagenes/menus/fondoMenu.png");
  inc = new Imagen("./imagenes/menus/incrementar.png", INC_X, INC_Y);
  dec = new Imagen("./imagenes/menus/decrementar.png", DEC_X, DEC_Y);

  // Altavoz cancelacion de sonido
  suena = new Imagen("./imagenes/sonando.png", 0, 0);
  nosuena = new Imagen("./imagenes/silencio.png", 0 , 0); 

  // Confirmar-Cancelar
  confirmar = new Imagen("./imagenes/confirmar.png", CONFIRMAR_X, CONFIRMAR_Y);
  cancelar = new Imagen("./imagenes/cancelar.png", CANCELAR_X, CANCELAR_Y);
}

void GestorJugadores::ver(Video *v)
{
  SDL_Event evento;
  Puntero p;
  int opc = 0;
  unsigned i = 0;

  cargarNombres();

  Musica musica("./sonidos/menu.wav");
  musica.reproducir();

  if (jugadores.empty()) {
    while (opc == 0) {
      pantallaNo(v);	
      while (SDL_PollEvent(&evento)) {    
	if (evento.type == SDL_QUIT)
	  opc = -1; // Salir  

	else if (evento.type == SDL_MOUSEBUTTONDOWN) {
	  p.actualizar();
	  
	  if (p.boton() == 1 && areaAltavoz(p)) {
	    musica.silenciar();
	  }

	  else if (p.boton() == 1 && areaCancelar(p)) {
	    opc = -1;
	  }
	}
      }
    }
  }

  else {
    j = new Jugador(jugadores[0]);

    // Bucle de seleccion del número de jugadores
    while (opc == 0) {
      actualizarPantalla(v);
      while (SDL_PollEvent(&evento)) {    
	if (evento.type == SDL_QUIT)
	  opc = -1; // Salir  
		
	else if (evento.type == SDL_MOUSEBUTTONDOWN) {
	  p.actualizar();
	
	  if (p.boton() == 1 && areaAltavoz(p)) {
	    musica.silenciar();
	  }

	  else if (p.boton() == 1 && areaCancelar(p)) {
	    opc = -1;
	  }

	  else if (p.boton() == 1 && areaIncremento(p)) {
	    if (i < jugadores.size() - 1)
	      i++;
	    else
	      i = 0;
	    if (j)
	      delete j;
	    j = new Jugador(jugadores[i]);
	  }
	  else if (p.boton() == 1 && areaDecremento(p)) {
	    if (i > 0)
	      i--;
	    else
	      i = jugadores.size() - 1;
	    if (j)
	      delete j;
	    j = new Jugador(jugadores[i]);
	  }
	}
      }
      SDL_Delay(1);
    }
  }
}
 
void GestorJugadores::borrar(Video *v)
{
  SDL_Event evento;
  Puntero p;
  int opc = 0;
  unsigned i = 0;

  cargarNombres();

  Musica musica("./sonidos/menu.wav");
  musica.reproducir();

  if (jugadores.empty()) {
    while (opc == 0) {
      pantallaNo(v);	
      while (SDL_PollEvent(&evento)) {    
	if (evento.type == SDL_QUIT)
	  opc = -1; // Salir  

	else if (evento.type == SDL_MOUSEBUTTONDOWN) {
	  p.actualizar();
	
	  if (p.boton() == 1 && areaAltavoz(p)) {
	    musica.silenciar();
	  }

	  else if (p.boton() == 1 && areaCancelar(p)) {
	    opc = -1;
	  }
	}
      }
    }
  }

  else {
    j = new Jugador(jugadores[0]);

    // Bucle de seleccion del número de jugadores
    while (opc == 0) {
      actualizarBorrar(v);
      while (SDL_PollEvent(&evento)) {    
	if (evento.type == SDL_QUIT)
	  opc = -1; // Salir  
	
	else if (evento.type == SDL_MOUSEBUTTONDOWN) {
	  p.actualizar();
	  
	  if (p.boton() == 1 && areaAltavoz(p)) {
	    musica.silenciar();
	  }

	  else if (p.boton() == 1 && areaConfirmar(p)) {
	    j->borrarJugador();
	    delete j;
	    opc = -1;
	  }

	  else if (p.boton() == 1 && areaCancelar(p)) {
	    opc = -1;
	  }

	  else if (p.boton() == 1 && areaIncremento(p)) {
	    if (i < jugadores.size() - 1)
	      i++;
	    else
	      i = 0;
	    if (j)
	      delete j;
	    j = new Jugador(jugadores[i]);
	  }
	  else if (p.boton() == 1 && areaDecremento(p)) {
	    if (i > 0)
	      i--;
	    else
	      i = jugadores.size() - 1;
	    if (j)
	      delete j;
	    j = new Jugador(jugadores[i]);
	  }
	}
      }
      SDL_Delay(1);
    }
  }

  while (!jugadores.empty())
    jugadores.erase(jugadores.begin());
}
 
void GestorJugadores::cargarNombres()
{
  fstream fichero;
  char buffer[10];
  string cBuffer;  

  // Abrimos el archivo para lectura
  fichero.open("./guardado/gestorJugadores.sav", fstream::in);
 
 // Mientras no hayamos llegado al final del fichero
  while (!fichero.eof()) {
    fichero.getline(buffer, 10, '\n');
    cBuffer = buffer;
    if (cBuffer != "")
      jugadores.push_back(cBuffer);
  }      
  // Cerramos el fichero
  fichero.close();
}

void GestorJugadores::actualizarBorrar(Video *v)
{
  stringstream datos;

  fondo->dibujar(v);
  inc->dibujar(v);
  dec->dibujar(v);

  confirmar->dibujar(v);
  cancelar->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  datos.str("");
  datos << "Selecciona jugador: ";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 92, 255, 255, 255);

  datos.str("");
  datos << "Borrar " << j->nombre() << "?";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 142, 255, 255, 255);

  datos.str("");
  datos << "Pulse confirmar para borrar o cancelar para salir";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 192, 255, 255, 255);

  v->actualizar();
}

void GestorJugadores::actualizarPantalla(Video *v)
{
  stringstream datos;

  fondo->dibujar(v);
  inc->dibujar(v);
  dec->dibujar(v);

  cancelar->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  datos.str("");
  datos << "Selecciona jugador: ";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 92, 255, 255, 255);

  datos.str("");
  datos << "Jugador " << j->nombre();
  textos.mostrarTexto(v, datos.str().c_str(), 64, 142, 255, 255, 255);

  datos.str("");
  datos << "Puntuacion general: " << j->puntuacionGeneral();
  textos.mostrarTexto(v, datos.str().c_str(), 64, 192, 255, 255, 255);

  datos.str("");
  datos << "Partidas  ganadas: " << j->partidasGanadas();
  textos.mostrarTexto(v, datos.str().c_str(), 64, 242, 255, 255, 255);

  datos.str("");
  datos << "Partidas perdidas: " << j->partidasPerdidas();
  textos.mostrarTexto(v, datos.str().c_str(), 64, 292, 255, 255, 255);

  datos.str("");
  datos << "Partidas abandonadas: " << j->partidasAbandonadas();
  textos.mostrarTexto(v, datos.str().c_str(), 64, 342, 255, 255, 255);

  datos.str("");
  datos << "Porcentaje ganadas: " << j->porGanadas() << " %";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 392, 255, 255, 255);

  datos.str("");
  datos << "Porcentaje perdidas: " << j->porPerdidas() << " %";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 442, 255, 255, 255);

  datos.str("");
  datos << "Porcentaje abandonadas: " << j->porAbandonadas() << " %";
  textos.mostrarTexto(v, datos.str().c_str(), 64, 492, 255, 255, 255);

  datos.str("");
  datos << "Rango: ";
  switch (j->rangoJugador()) {
  case Jugador::NOVEL: datos << "NOVEL"; break;
    case Jugador::MEDIO: datos << "MEDIO"; break;
    case Jugador::AVANZADO: datos << "AVANZADO"; break;
    case Jugador::EXPERTO: datos << "EXPERTO"; break;
  }
  textos.mostrarTexto(v, datos.str().c_str(), 64, 542, 255, 255, 255);

  v->actualizar();
}

void GestorJugadores::pantallaNo(Video *v)
{
  stringstream datos;

  fondo->dibujar(v);

  cancelar->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  datos.str("");
  datos << "No existe ningun jugador en el sistema";
  textos.mostrarTexto(v, datos.str().c_str(), 104, 370, 255, 255, 255);

  v->actualizar();
}

bool GestorJugadores::areaIncremento(const Puntero& p)
{
return ((p.posX() >= INC_X && p.posX() < INC_XW) && (p.posY() >= INC_Y && p.posY() < INC_YH));
}

bool GestorJugadores::areaDecremento(const Puntero& p)
{
return ((p.posX() >= DEC_X && p.posX() < DEC_XW) && (p.posY() >= DEC_Y && p.posY() < DEC_YH));
}

