#include <iostream>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>
#include "iniciado.h"

using namespace std;

Iniciado::Iniciado()
{
  if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO) < 0) {
    cerr << "No se pudo inicializar SDL: " << SDL_GetError() << endl;
    exit(1);
  }

  if (Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 4096) < 0) {
    cerr << "Subsistema de auido no disponible" << endl;
    exit(1);
  }

  if (TTF_Init() < 0) {
    cerr << "No se pudo inicializar TTF" << endl;
    exit(1);
  }
}

Iniciado::~Iniciado()
{
  TTF_Quit();
  Mix_CloseAudio();
  SDL_Quit();
}
