#include <iostream>
#include <sstream>
#include "constantes.h"
#include "menu.h"

extern bool silencio;

using namespace std;

Menu::Menu(): opcion("./sonidos/correcto.wav"), descripcion("./fuentes/IMPACT.TTF", 30)
{
  fondo = new Imagen("./imagenes/menus/fondoMenu.png");

  // Altavoz cancelacion de sonido
  suena = new Imagen("./imagenes/sonando.png", 0, 0);
  nosuena = new Imagen("./imagenes/silencio.png", 0 , 0);

  // Opciones menu principal
  jugarN = new Imagen("./imagenes/menus/opciones/jNegro.png", JUGAR_X, JUGAR_Y);
  jugarR = new Imagen("./imagenes/menus/opciones/jRojo.png", JUGAR_X, JUGAR_Y);
  jugadoresN = new Imagen("./imagenes/menus/opciones/juNegro.png", JUGADORES_X, JUGADORES_Y);
  jugadoresR = new Imagen("./imagenes/menus/opciones/juRojo.png", JUGADORES_X, JUGADORES_Y);
  salirN = new Imagen("./imagenes/menus/opciones/sNegro.png", SALIR_X, SALIR_Y);
  salirR = new Imagen("./imagenes/menus/opciones/sRojo.png", SALIR_X, SALIR_Y);

  // Opciones menu partida
  simpleN = new Imagen("./imagenes/menus/opciones/spNegro.png", SIMPLE_X, SIMPLE_Y);
  simpleR = new Imagen("./imagenes/menus/opciones/spRojo.png", SIMPLE_X, SIMPLE_Y);
  concursoN = new Imagen("./imagenes/menus/opciones/cNegro.png", CONCURSO_X, CONCURSO_Y);
  concursoR = new Imagen("./imagenes/menus/opciones/cRojo.png", CONCURSO_X, CONCURSO_Y);
  volverN = new Imagen("./imagenes/menus/opciones/vNegro.png", VOLVER_X, VOLVER_Y);
  volverR = new Imagen("./imagenes/menus/opciones/vRojo.png", VOLVER_X, VOLVER_Y);

  // Opciones menu jugadores
  verN = new Imagen("./imagenes/menus/opciones/vrNegro.png", VER_X, VER_Y);
  verR = new Imagen("./imagenes/menus/opciones/vrRojo.png", VER_X, VER_Y);
  borrarN = new Imagen("./imagenes/menus/opciones/bNegro.png", BORRAR_X, BORRAR_Y);
  borrarR = new Imagen("./imagenes/menus/opciones/bRojo.png", BORRAR_X, BORRAR_Y);
}

int Menu::menuPpal(Video *v)
{
  SDL_Event evento;
  Puntero p;
  int opc = 0;

  Musica musica("./sonidos/menu.wav");

  musica.reproducir();

  while (opc == 0) {
    actualizarPpal(v);
    while (SDL_PollEvent(&evento)) {
      if (evento.type == SDL_QUIT)
	opc = 2; // Salir
      
      else if (evento.type == SDL_MOUSEBUTTONDOWN) {
	p.actualizar();
	
	if (p.boton() == 1 && areaAltavoz(p)) {
	  musica.silenciar();
	}

	else if (p.boton() == 1 && areaJugar(p)) {
	  opc = 1;
	  opcion.reproducir();
	}

	else if (p.boton() == 1 && areaJugadores(p)) {
	  opc = 2;
	  opcion.reproducir();
	}

	else if (p.boton() == 1 && areaSalir(p)) {
	  opc = 3;
	}
      }
    }
    SDL_Delay(1);
  }

  return opc;
}

int Menu::menuJugar(Video *v)
{
  SDL_Event evento;
  Puntero p;
  int opc = 0;
  Musica musica("./sonidos/menu.wav");

  musica.reproducir();

  while (opc == 0) {
    actualizarJugar(v);
    while (SDL_PollEvent(&evento)) {      
      if (evento.type == SDL_MOUSEBUTTONDOWN) {
	p.actualizar();
	
	if (p.boton() == 1 && areaAltavoz(p)) {
	  musica.silenciar();
	}

	else if (p.boton() == 1 && areaSimple(p)) {
	  opc = 1;
	  opcion.reproducir();
	}
	else if (p.boton() == 1 && areaConcurso(p)) {
	  opc = 2;
	  opcion.reproducir();
	}

	else if (p.boton() == 1 && areaVolver(p)) {
	  opc = 3;
	  opcion.reproducir();
	}
      }
    }
    SDL_Delay(1);
  }

  return opc;
}

int Menu::menuJugadores(Video *v)
{
  SDL_Event evento;
  Puntero p;
  int opc = 0;
  Musica musica("./sonidos/menu.wav");

  musica.reproducir();

  while (opc == 0) {
    actualizarJugadores(v);
    while (SDL_PollEvent(&evento)) {      
      if (evento.type == SDL_MOUSEBUTTONDOWN) {
	p.actualizar();
	
	if (p.boton() == 1 && areaAltavoz(p)) {
	  musica.silenciar();
	}

	else if (p.boton() == 1 && areaVer(p)) {
	  opc = 1;
	  opcion.reproducir();
	}
	else if (p.boton() == 1 && areaBorrar(p)) {
	  opc = 2;
	  opcion.reproducir();
	}

	else if (p.boton() == 1 && areaVolver(p)) {
	  opc = 3;
	  opcion.reproducir();
	}
      }
    }
    SDL_Delay(1);
  }

  return opc;
}

Menu::~Menu() {}

void Menu::actualizarPpal(Video *v)
{
  // Variable de posición
  Puntero p;
  p.actualizar();

  // Variable de texto
  stringstream datos;
 
  fondo->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  if (areaJugar(p)) {
    jugarR->dibujar(v);
    datos.str("");
    datos << "Juega una partida rapida"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 630, 375, 255, 255, 255);
    datos.str("");
    datos << "a Freerummi o participa";
    descripcion.mostrarTexto(v, datos.str().c_str(), 637, 405, 255, 255, 255);
    datos.str("");
    datos << "en un concurso";
    descripcion.mostrarTexto(v, datos.str().c_str(), 690, 435, 255, 255, 255);
  } 

  else
    jugarN->dibujar(v);

if (areaJugadores(p)) {
    jugadoresR->dibujar(v);
    datos.str("");
    datos << "Gestiona las opciones"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 640, 375, 255, 255, 255);
    datos.str("");
    datos << "de los jugadores";
    descripcion.mostrarTexto(v, datos.str().c_str(), 677, 405, 255, 255, 255);
    } 

  else
    jugadoresN->dibujar(v);

  if (areaSalir(p)) {
    salirR->dibujar(v);
    datos.str("");
    datos << "Volver a Linux"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 700, 400, 255, 255, 255);
  }

  else
    salirN->dibujar(v);

  v->actualizar();
}

void Menu::actualizarJugar(Video *v)
{
  // Variable de posicion
  Puntero p;
  p.actualizar();

  // Variable de texto
  stringstream datos;

  fondo->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  if (areaSimple(p)) {
    simpleR->dibujar(v);
    datos.str("");
    datos << "Juega una partida rapida"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 630, 375, 255, 255, 255);
    datos.str("");
    datos << "contra nuestros robots";
    descripcion.mostrarTexto(v, datos.str().c_str(), 640, 405, 255, 255, 255);
    datos.str("");
    datos << "para adquirir experiencia";
    descripcion.mostrarTexto(v, datos.str().c_str(), 630, 435, 255, 255, 255);
  }
   
  else
    simpleN->dibujar(v);

  if (areaConcurso(p)) {
    concursoR->dibujar(v);
    datos.str("");
    datos << "Participa en un concurso"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 630, 375, 255, 255, 255);
    datos.str("");
    datos << "de tantas rondas como";
    descripcion.mostrarTexto(v, datos.str().c_str(), 645, 405, 255, 255, 255);
    datos.str("");
    datos << "participantes seais";
    descripcion.mostrarTexto(v, datos.str().c_str(), 665, 435, 255, 255, 255);
  }
  else
    concursoN->dibujar(v);

  if (areaVolver(p)) {
    volverR->dibujar(v);
    datos.str("");
    datos << "Volver atras"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 715, 400, 255, 255, 255);
  }
  else
    volverN->dibujar(v);

  v->actualizar();
}

void Menu::actualizarJugadores(Video *v)
{
// Variable de posicion
  Puntero p;
  p.actualizar();

  // Variable de texto
  stringstream datos;

  fondo->dibujar(v);

  if (!silencio)
    suena->dibujar(v);
  else
    nosuena->dibujar(v);

  if (areaVer(p)) {
    verR->dibujar(v);
    datos.str("");
    datos << "Analiza los perfiles"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 670, 375, 255, 255, 255);
    datos.str("");
    datos << "de los jugadores de";
    descripcion.mostrarTexto(v, datos.str().c_str(), 668, 405, 255, 255, 255);
    datos.str("");
    datos << "FreeRummi";
    descripcion.mostrarTexto(v, datos.str().c_str(), 730, 435, 255, 255, 255);
  }
   
  else
    verN->dibujar(v);

  if (areaBorrar(p)) {
    borrarR->dibujar(v);
    datos.str("");
    datos << "Elimina el perfil de"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 660, 375, 255, 255, 255);
    datos.str("");
    datos << "uno o varios jugadores";
    descripcion.mostrarTexto(v, datos.str().c_str(), 645, 405, 255, 255, 255);
  }

  else
    borrarN->dibujar(v);

  if (areaVolver(p)) {
    volverR->dibujar(v);
    datos.str("");
    datos << "Volver atras"; 
    descripcion.mostrarTexto(v, datos.str().c_str(), 715, 400, 255, 255, 255);
  }
  else
    volverN->dibujar(v);

  v->actualizar();
}

bool Menu::areaJugar(const Puntero& p)
{
  return ((p.posX() >= JUGAR_X && p.posX() < JUGAR_XW) && (p.posY() >= JUGAR_Y && p.posY() < JUGAR_YH));
}

bool Menu::areaJugadores(const Puntero& p)
{
  return ((p.posX() >= JUGADORES_X && p.posX() < JUGADORES_XW) && (p.posY() >= JUGADORES_Y && p.posY() < JUGADORES_YH));
}

bool Menu::areaSalir(const Puntero& p) 
{
  return ((p.posX() >= SALIR_X && p.posX() < SALIR_XW) && (p.posY() >= SALIR_Y && p.posY() < SALIR_YH));
}

bool Menu::areaSimple(const Puntero& p)
{
  return ((p.posX() >= SIMPLE_X && p.posX() < SIMPLE_XW) && (p.posY() >= SIMPLE_Y && p.posY() < SIMPLE_YH));
}

bool Menu::areaConcurso(const Puntero& p) 
{
  return ((p.posX() >= CONCURSO_X && p.posX() < CONCURSO_XW) && (p.posY() >= CONCURSO_Y && p.posY() < CONCURSO_YH));
}

bool Menu::areaVolver(const Puntero& p)
{
  return ((p.posX() >= VOLVER_X && p.posX() < VOLVER_XW) && (p.posY() >= VOLVER_Y && p.posY() < VOLVER_YH));
}

bool Menu::areaVer(const Puntero& p)
{
  return ((p.posX() >= VER_X && p.posX() < VER_XW) && (p.posY() >= VER_Y && p.posY() < VER_YH));
}

bool Menu::areaBorrar(const Puntero& p)
{
  return ((p.posX() >= BORRAR_X && p.posX() < BORRAR_XW) && (p.posY() >= BORRAR_Y && p.posY() < BORRAR_YH));
}
