#include <iostream>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include "video.h"
#include "constantes.h"
#include "puntero.h"
#include "monton.h"

using namespace std;

Monton::Monton(): fichRest(106), sigExt(NULL)
{
  Color c;
  mon.push_back(Ficha(true, 1));
  mon.push_back(Ficha(true, 2));

  for (int i = 0; i < 4; i++) {
    for (int j = 1; j <=13; j++) {
      switch(i)
	{
	case 0: c = VERDE; break;
	case 1: c = AZUL; break;
	case 2: c = ROJO; break;
	case 3: c = NEGRO; break;
	}
      mon.push_back(Ficha(false, j, c));
      mon.push_back(Ficha(false, j, c));
    }
  }
  desordenar();
} 

const Ficha& Monton::extraer()
{
  sigExt = mon[0];

  mon.erase(mon.begin());

  fichRest--;

  return sigExt;
}

void Monton::desordenar()
{
  srand(time(0)); // Iniciamos la semilla

  random_shuffle(mon.begin(), mon.end());
}

bool areaMonton(const Puntero& p) 
{
  return ((p.posX() >= MONTON_X && p.posX() < MONTON_XW) && (p.posY() >= MONTON_Y && p.posY() < MONTON_YH));
}
