#include <iostream>
#include "constantes.h"
#include "sonido.h"

bool silencio = false;

using namespace std;

Efecto::Efecto(const char* ruta)
{
  efecto = Mix_LoadWAV(ruta);

  if (efecto == NULL) {
    cerr << "No se puede cargar el sonido" << endl;
    exit(1);
  }
}

void Efecto::reproducir(int loops)
{
  if (!silencio) {
    
    int volumen = 50;
    
    Mix_VolumeChunk(efecto, volumen);
    
    Mix_AllocateChannels(2);
    
    Mix_PlayChannel(-1, efecto, loops);
  }
}

Musica::Musica(const char* ruta)
{
    musica = Mix_LoadMUS(ruta);

    if(musica == NULL)
    {
        cerr<<"Imposible abrir el archivo de audio: "<<SDL_GetError()<<endl;
        exit(1);
    }
}

void Musica::silenciar()
{
  if (!silencio) {
    silencio = true;
    pausa();
  }

  else {
    silencio = false;
    reproducir();
  }
}

void Musica::pausa() {
  Mix_PauseMusic(); 
}

void Musica::continuar() {
  if (!silencio) 
    Mix_ResumeMusic();
}

void Musica::reproducir()
{
  if (!silencio) {
    int volumen = 20;
    
    Mix_VolumeMusic(volumen);
    
    Mix_PlayMusic(musica,-1);
  }
}

bool areaAltavoz(const Puntero& p)
{
  return ((p.posX() >= ALTAVOZ_X && p.posX() < ALTAVOZ_XW) && (p.posY() >= ALTAVOZ_Y && p.posY() < ALTAVOZ_YH));
}


